; SuperBASIC interface for PROforma
; written by Joachim Van der Auwera,
; based on the DATAdesign SuperBASIC interface by the same author,
; written for PROGS, Professional & Graphical Software
; (c) 1993, between 19 December 1993 and 20 October 1994 for PROforma v1.00 &up
; started on version for PROforma v1.10 and up on 13 September 1996
; 11.11.1996 added PFGstateSave and PFGstateRestore
; 01.12.1996 added PFCTMRestoreKeep, PFArcTo, PFPArcTo, PFArcR, PFPArcR,
;	   PFCircle, PFPie, PFRectangle, PFPRectangle, PFPShow, PFPWidth
; 04.12.1996 added PFPatternMask, PFPatternMaskUser, PFPFontBbox
; 26.12.1996 added PFFontCalculate
        include asm_aid_mac
        include asm_macro_jvda
        include asm_qdos_sms
        include asm_keys_thg
        include asm_keys_qlv
        include asm_keys_err
        include asm_keys_sys
        section text

        xdef    pf_link
        xdef    pfprocs
;
linkmess
        dc.w    endmess-*-2
        dc.b    'PROforma Sbasic interface installed',10
        dc.b    '(c) 1993-1996 PROGS',10
endmess
        dc.b    'v1.03'
        xref    _LinkPROforma
        dc.w    _LinkPROforma-* ; make address even etc.
****************************************************************************
*
* v1.00 initial version
* v1.01 for PROforma v1.10 onwards
* v1.02 added some extra commands
* v1.03 added some more commands
*
****************************************************************************
pf_link move.w  bi.inipr,a0
        lea     pfprocs(pc),a1
        jmp     (a0)      ; link new SuperBASIC command


exte    macro   name
        dc.w    [name]-*
        dc.b    [.len(name)]
        dc.b    '[name]'
        endm

exte2   macro   name,rout
        dc.w    [rout]-*
        dc.b    [.len(name)]
        dc.b    '[name]'
        endm

extr    macro   name
        dc.w    [name]-*
        dc.b    [.len(name)]+1
        dc.b    '[name]$'
        endm

extr2   macro   name,rout
        dc.w    [rout]-*
        dc.b    [.len(name)]+1
        dc.b    '[name]$'
        endm

pfprocs dc.w    240       ; 'nr' of procedures
    exte	    PFGstateInit
    exte	    PFGstateRemove
    exte	    PFGstateSave
    exte	    PFGstateRestore
    exte	    PFLineWidth
    exte	    PFFlatness
    exte	    PFCTMSave
    exte	    PFCTMRestore
    exte	    PFCTMRestoreKeep
    exte	    PFCTMReset
    exte	    PFCTMSet
    exte	    PFPathMethod
    exte	    PFPathClose
    exte	    PFPathClear
    exte	    PFPathDraw
    exte	    PFPathClip
    exte	    PFMoveTo
    exte	    PFMoveR
    exte	    PFLineTo
    exte	    PFLineR
    exte	    PFCurveTo
    exte	    PFCurveR
    exte	    PFArcTo
    exte	    PFArcR
    exte	    PFCircle
    exte	    PFPie
    exte	    PFRectangle
    exte	    PFPageClear
    exte	    PFPageShow
    exte	    PFPageScroll
    exte	    PFPageScale
    exte	    PFPageBboxReset
    exte	    PFPageBboxRestore
    exte	    PFPageBboxSet
    exte	    PFPageBboxGet
    exte	    PFPageBboxFullGet
    exte	    PFPageOriginSet
    exte	    PFClipClear
    exte	    PFFontScale
    exte	    PFFontLoad
    exte	    PFFontUnLoad
    exte	    PFFontSelect
    exte	    PFFontBbox
    exte	    PFFontNext
    exte	    PFFontCount
    exte	    PFFontCountAll
    exte	    PFWindowSubRestore
    exte	    PFWindowSubSet
    exte	    PFBufferUpdate
    exte	    PFBufferSave
    exte	    PFBufferRestore
    exte	    PFDriverCount
    exte	    PFCharAvailable
    exte	    PFCharPathInit
    exte	    PFCharPathEl
    exte2   PFShow	        , PFStringShow
    exte2   PFShowKern      , PFStringShowKern
    exte2   PFShowKernJust  , PFStringShowKernJust
    exte2   PFShowJust      , PFStringShowJust
    exte2   PFShowTrack     , PFStringShowTrack
    exte2   PFWidth         , PFStringWidth
    exte2   PFWidthKern     , PFStringWidthKern
    exte	    PFColourGray
    exte	    PFColourRGB
    exte	    PFColourCMYK
    exte	    PFPaperColourGray
    exte	    PFPaperColourRGB
    exte	    PFPaperColourCMYK
    exte	    PFPatternMask
    exte	    PFPatternMaskUser
    exte	    PFPrintEscape
    exte	    PFExtraEOS
    exte	    PFCopies
    exte	    PFCacheUse
    exte	    PFDisplayMode
    exte	    PFPictureCount
    exte	    PFPictureRecognize
    exte	    PFPictureRatio
    exte	    PFPictureColourCount
    exte	    PFPictureDisplay
    exte	    PFFontCalculate
    exte	    PFPGstateInit
    exte	    PFPGstateReAssign
    exte	    PFPFontBbox
    exte2   PFPShow         , PFPStringShow
    exte2   PFPWidth        , PFPStringWidth
    exte	    PFPMoveTo
    exte	    PFPMoveR
    exte	    PFPLineTo
    exte	    PFPLineR
    exte	    PFPCurveTo
    exte	    PFPCurveR
    exte	    PFPArcTo
    exte	    PFPArcR
    exte	    PFPRectangle
    exte	    PFPPageScroll
    exte	    PFPPageBboxSet
    exte	    PFPPageBboxGet
    exte	    PFPPageBboxFullGet
    exte	    PFPPageOriginSet
    exte	    PFPWindowMove
    exte	    PFPWindowSubSet
    dc.w	    0,24	      ; end of procedures + 'nr' of functions
    extr	    PFFontNameGet
    extr	    PFFontWeightGet
    extr	    PFFontFamilyGet
    extr	    PFFontNoticeGet
    extr	    PFFontVersionGet
    extr	    PFFontNextName
    extr	    PFDriverNext
    extr	    PFPictureNext
        dc.w    0	      ; end of functions

; all routines are built with macro's
        include asm_PFbasic_in
; all routines (except PFGstateInit) need a Gstate as first parameter
; all routines are procedures, except some which return a string

 rout PFGstateRemove        , nopar
        Gstate
        justdo

 dummy PFCTMSave	        , nopar
 dummy PFCTMRestore         , nopar
 dummy PFCTMRestoreKeep     , nopar
 dummy PFCTMReset	        , nopar
 dummy PFPathClose	        , nopar
 dummy PFPathClear	        , nopar
 dummy PFPathDraw	        , nopar
 dummy PFPathClip	        , nopar
 dummy PFPageClear	        , nopar
 dummy PFPageShow	        , nopar
 dummy PFPageBboxReset      , nopar
 dummy PFPageBboxRestore    , nopar
 dummy PFClipClear	        , nopar
 dummy PFFontNext	        , nopar
 dummy PFWindowSubRestore   , nopar
 dummy PFBufferUpdate       , nopar
 dummy PFBufferSave         , nopar
 dummy PFBufferRestore      , nopar
 dummy PFGstateSave         , nopar
 dummy PFGstateRestore      , nopar
 dummy PFFontCalculate      , nopar

 rout PFLineWidth	        , ptpar
        Gstate
pt_1    pt
        justdo

 dummy PFFlatness	        , ptpar
 dummy PFColourGray         , ptpar
 dummy PFPaperColourGray    , ptpar
 dummy PFPageScale	        , ptpar
 dummy PFFontScale	        , ptpar
 dummy PFCircle	        , ptpar

 rout PFPatternMask
        Gstate
        short
        justdo

 rout PFPathMethod	        , lpar
        Gstate
long_1  long
        justdo

 dummy PFCharAvailable      , lpar
 dummy PFCharPathInit       , lpar
 dummy PFPrintEscape        , lpar
 dummy PFExtraEOS	        , lpar
 dummy PFCopies	        , lpar
 dummy PFCacheUse	        , lpar
 dummy PFDisplayMode        , lpar
 dummy PFPatternMaskUser    , lpar

 rout PFMoveTo	    , pt2par
        Gstate
pt_2    pt
        bra     pt_1

 dummy PFMoveR	    , pt2par
 dummy PFLineTo	    , pt2par
 dummy PFLineR	    , pt2par
 dummy PFPageScroll         , pt2par
 dummy PFPageOriginSet      , pt2par
 dummy PFPMoveTo	        , pt2par
 dummy PFPMoveR	    , pt2par
 dummy PFPLineTo	        , pt2par
 dummy PFPLineR	    , pt2par

 rout PFRectangle
        Gstate
        pt
        bra     pt_2

 rout PFPageBboxSet         , pt4par
        Gstate
pt_4    pt
        pt
        bra     pt_2

 dummy PFWindowSubSet       , pt4par
 dummy PFArcTo	        , pt4par
 dummy PFArcR	        , pt4par
 dummy PFPArcTo	        , pt4par
 dummy PFPArcR	        , pt4par
 dummy PFPRectangle         , pt4par

 rout PFCTMSet	    , pt6par
        Gstate
        pt
        pt
        bra     pt_4

 dummy PFCurveTo	        , pt6par
 dummy PFCurveR	    , pt6par
 dummy PFPCurveTo	        , pt6par
 dummy PFPCurveR	        , pt6par

 rout PFPie
        Gstate
        pt
        pt
        pt
        pt
        pt
        short
        justdo

 rout PFFontLoad	        , strpar
        Gstate
        qlstr
        justdo

 dummy PFFontSelect         , strpar
 dummy PFFontUnload         , strpar
 dummy PFStringShow         , strpar
 dummy PFStringShowKern     , strpar
 dummy PFPStringShow        , strpar

 rout PFFontNameget         , strret
        Gstate
        move.l  a4,(a1)+
        do
        move.l  a4,a5
        bra     retstr

 dummy PFFontWeightGet      , strret
 dummy PFFontFamilyGet      , strret
 dummy PFFontNoticeGet      , strret
 dummy PFFontVersionGet     , strret
 dummy PFFontNextName       , strret

 rout PFGstateInit
        add.w   #16,a2     ; reserve room for 2 ret values
        id
        qlstr
        bbox
_init   move.l  a4,(a1)+	; place for Gstate
        move.l  a3,4(a4)
        bsr     get_long
        lea     10(a4),a0	; place for passes
        move.l  a0,(a1)+
        bsr     get_long
        clr.l   8(a4)
        do
        move.l  4(a4),a3	; update Gstate
        move.l  (a4),d7
        bsr     update
        move.l  8(a4),d7
        bsr     update
        finish

 rout PFPGstateInit
        add.w   #16,a2     ; reserve room for 2 ret values
        id
        qlstr
        pbbox
        bra     _init

 rout PFPageBboxGet
        Gstate
        move.l  a3,24(a4)	; we have to fill in the return values later
        bsr     get_pt    ; xsiz pagebbox
        bsr     get_pt    ; ysiz pagebbox
        bsr     get_pt    ; xpos pagebbox
        bsr     get_pt    ; ypos pabebbox
        bsr     get_pt    ; xpageorg
        bsr     get_pt    ; ypageorg
        move.l  a4,(a1)+	; place to fill in PageBbox
        do
        move.l  24(a4),a3
        move.l  0(a4),d7	; value to update with
        bsr     updatept
        move.l  4(a4),d7	; value to update with
        bsr     updatept
        move.l  8(a4),d7	; value to update with
        bsr     updatept
        move.l  12(a4),d7	; value to update with
        bsr     updatept
        move.l  16(a4),d7	; value to update with
        bsr     updatept
        move.l  20(a4),d7	; value to update with
        bsr     updatept
        finish

 rout PFPageBboxFullGet     , bbox4
        Gstate
        move.l  a3,24(a4)	; we have to fill in the return values later
        bsr     get_pt    ; xsiz pagebbox
        bsr     get_pt    ; ysiz pagebbox
        bsr     get_pt    ; xpos pagebbox
        bsr     get_pt    ; ypos pabebbox
        move.l  a4,(a1)+	; place to fill in FullPageBbox
        do
        move.l  24(a4),a3
        move.l  0(a4),d7	; value to update with
        bsr     updatept
        move.l  4(a4),d7	; value to update with
        bsr     updatept
        move.l  8(a4),d7	; value to update with
        bsr     updatept
        move.l  12(a4),d7	; value to update with
        bsr     updatept
        finish

 dummy PFFontBbox	        , bbox4

 rout PFPFontBbox
        Gstate
        move.l  a3,24(a4)	; we have to fill in the return values later
        bsr     get_long	; xsiz pagebbox
        bsr     get_long	; ysiz pagebbox
        bsr     get_long	; xpos pagebbox
        bsr     get_long	; ypos pabebbox
        move.l  a4,(a1)+	; place to fill in FullPageBbox
        do
        move.l  24(a4),a3
        move.l  0(a4),d7	; value to update with
        bsr     update
        move.l  4(a4),d7	; value to update with
        bsr     update
        move.l  8(a4),d7	; value to update with
        bsr     update
        move.l  12(a4),d7	; value to update with
        bsr     update
        finish

 rout PFFontCount	        , retint
        Gstate
        move.l  a3,4(a4)
        bsr     get_long
        move.l  a4,(a1)+
        do
        move.l  4(a4),a3	; place for update
        move.l  (a4),d7   ; value to update with
        bsr     update
        finish

 dummy PFFontCountAll       , retint
 dummy PFDriverCount        , retint
 dummy PFPictureCount       , retint

 rout PFDriverNext	        , cycstr
        addq.l  #8,a2     ; need room for update
        Gstate
        move.l  a3,4(a4)
        bsr     get_long
        move.l  a4,(a1)+
        move.l  a2,(a1)+	; place for string
        do
        move.l  4(a4),a3	; place for update
        move.l  (a4),d7   ; value to update with
        bsr     update
        lea     8(a4),a5	; place with return string
        bra     retstr

 dummy PFPictureNext        , cycstr

 rout PFCharPathEl
        gstate
        move.l  a3,28(a4)	; we have to fill in the return values later
        bsr     get_long	; command
        lea     2(a4),a0
        move.l  a0,(a1)+
        clr.l   (a4)
        bsr     get_pt    ; x1
        lea     4(a4),a0
        move.l  a0,(a1)+
        bsr     get_pt    ; y1
        lea     8(a4),a0
        move.l  a0,(a1)+
        bsr     get_pt    ; x2
        lea     12(a4),a0
        move.l  a0,(a1)+
        bsr     get_pt    ; y2
        lea     16(a4),a0
        move.l  a0,(a1)+
        bsr     get_pt    ; x3
        lea     20(a4),a0
        move.l  a0,(a1)+
        bsr     get_pt    ; y3
        lea     24(a4),a0
        move.l  a0,(a1)+
        do
        move.l  28(a4),a3
        move.l  0(a4),d7	; value to update with
        bsr     update
        move.l  4(a4),d7	; value to update with
        bsr     updatept
        move.l  8(a4),d7	; value to update with
        bsr     updatept
        move.l  12(a4),d7	; value to update with
        bsr     updatept
        move.l  16(a4),d7	; value to update with
        bsr     updatept
        move.l  20(a4),d7	; value to update with
        bsr     updatept
        move.l  24(a4),d7	; value to update with
        bsr     updatept
        finish

 rout PFStringShowTrack     , strpt
        Gstate
        qlstr
        bra     pt_1

 dummy PFStringShowJust     , strpt
 dummy PFStringShowKernJust , strpt

 rout PFStringWidth         , width
        addq.l  #8,a2     ; room for update width
        Gstate
        qlstr
        clr.l   (a4)
        move.l  a3,4(a4)
        bsr     get_pt
        move.l  a4,(a1)+
        do
        move.l  4(a4),a3
        move.l  (a4),d7   ; value to update with
        bsr     updatept
        finish

 dummy PFStringWidthKern    , width
 dummy PFPStringWidth       , width

 rout PFColourRGB	        , rgb
        Gstate
        move.l  a4,(a1)+
        exg     a1,a2
pt_3e   pt
        pt
        pt
        exg     a1,a2
        justdo

 dummy PFPaperColourRGB     , rgb

 rout PFColourcmyk	        , cmyk
        Gstate
        move.l  a4,(a1)+
        exg     a1,a2
        pt
        bra     pt_3e

 dummy PFPaperColourCMYK    , cmyk

 rout PFPictureRecognize
        Gstate
        id
        bra     long_1

 rout PFPictureRatio
        Gstate
        add.w   #12,a2
        id
        long
        move.l  a3,8(a4)
        move.l  a4,(a1)+
        bsr     get_long
        lea     4(a4),a0	; place for passes
        move.l  a0,(a1)+
        bsr     get_long
        do
        move.l  8(a4),a3	; update Gstate
        move.l  (a4),d7
        bsr     update
        move.l  4(a4),d7
        bsr     update
        finish

 rout PFPictureColourCount
        Gstate
        addq.l  #8,a2
        id
        long
        move.l  a3,4(a4)
        bsr     get_long
        move.l  a4,(a1)+
        do
        move.l  4(a4),a3
        move.l  (a4),d7
        bsr     update
        finish

 rout PFPictureDisplay
        Gstate
        id
        long
        bra     pt_2

 rout PFPGstateReAssign
        Gstate
        id
sh_4    short
        short
sh_2    short
        short
        justdo

 rout PFPPageScroll         , shsh
        Gstate
        bra     sh_2

 dummy PFPPageOriginSet     , shsh
 dummy PFPWindowMove        , shsh

 rout PFPPageBboxSet        , sh4
        Gstate
        bra     sh_4

 dummy PFPWindowSubSet      , sh4

 rout PFPPageBboxGet
        Gstate
        move.l  a3,24(a4)	; we have to fill in the return values later
        bsr     get_long	; xsiz pagebbox
        bsr     get_long	; ysiz pagebbox
        bsr     get_long	; xpos pagebbox
        bsr     get_long	; ypos pabebbox
        bsr     get_pt    ; xpageorg
        bsr     get_pt    ; ypageorg
        move.l  a4,(a1)+	; place to fill in PageBbox
        do
        move.l  24(a4),a3
        move.l  0(a4),d7	; value to update with
        bsr     update
        move.l  4(a4),d7	; value to update with
        bsr     update
        move.l  8(a4),d7	; value to update with
        bsr     update
        move.l  12(a4),d7	; value to update with
        bsr     update
        move.l  16(a4),d7	; value to update with
        bsr     updatept
        move.l  20(a4),d7	; value to update with
        bsr     updatept
        finish

 rout PFPPageBboxFullGet
        Gstate
        move.l  a3,24(a4)	; we have to fill in the return values later
        bsr     get_long	; xsiz pagebbox
        bsr     get_long	; ysiz pagebbox
        bsr     get_long	; xpos pagebbox
        bsr     get_long	; ypos pabebbox
        move.l  a4,(a1)+	; place to fill in PageBbox
        do
        move.l  24(a4),a3
        move.l  0(a4),d7	; value to update with
        bsr     update
        move.l  4(a4),d7	; value to update with
        bsr     update
        move.l  8(a4),d7	; value to update with
        bsr     update
        move.l  12(a4),d7	; value to update with
        bsr     update
        finish
;
    end
