/*
	ProWesS, PROGS Windowing System

	core routines
	memory allocation and release in types

	(c) PROGS, Professional & Graphical Software
	written by Joachim Van der Auwera
	started 13 February 1996
	06.03.1996 fixed bug in PWRelease, where object was released (not base)
*/

#include "PWHandler.h"

#define catch(X) do { if (err=(X)) return err; } while (0)

Error PWAllocate(PWSystem *system, Size size, void **ret)
{
	Error err;
	catch( MEMHeapAllocate(system->heap,size,ret) );
	MEMClear(size,*ret);
	return err;
}

Error PWRelease(PWObject object, void *base)
{
	return MEMHeapRelease(object->event.region->system->heap,base);
}
